--- php-8.4.18/ext/opcache/tests/gh21227.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/tests/gh21227.phpt	2026-04-01 04:35:36.014563601 +0000
@@ -0,0 +1,23 @@
+--TEST--
+GH-21227: Borked SCCP of array containing partial object
+--CREDITS--
+Daniel Chong (chongwick)
+--EXTENSIONS--
+opcache
+--INI--
+opcache.enable=1
+opcache.enable_cli=1
+--FILE--
+<?php
+
+function test() {
+    $obj->a = 3;
+    $objs = [];
+    $obj = new stdClass;
+    $objs[] = $obj;
+}
+
+?>
+===DONE===
+--EXPECT--
+===DONE===
diff '--color=auto' -Naur php-8.4.18/ext/opcache/tests/jit/gh20838.inc php-8.4.20RC1/ext/opcache/tests/jit/gh20838.inc
--- php-8.4.18/ext/opcache/tests/jit/gh20838.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/tests/jit/gh20838.phpt	2026-04-01 04:35:36.014783507 +0000
@@ -0,0 +1,66 @@
+--TEST--
+GH-20838 (JIT compiler produces wrong arithmetic results)
+--INI--
+opcache.enable=1
+opcache.enable_cli=1
+opcache.jit=tracing
+opcache.jit_buffer_size=64M
+opcache.jit_hot_loop=61
+opcache.jit_hot_func=127
+opcache.jit_hot_return=8
+opcache.jit_hot_side_exit=8
+--EXTENSIONS--
+opcache
+--FILE_EXTERNAL--
+gh20838.inc
+--EXPECT--
+49 0
+1080 18
+4415 31.25
+4763 75
+4926 75
+4933 60
+4935 75
+4938 75
+4939 75
+4947 60
+4952 45
+4953 75
+4962 60
+8558 45
+14888 45
+16879 13
+100003 0
+100007 60
+100013 0
+100017 13
+100019 15
+100027 45
+100031 30
+106427 -37.5
+217955 -9
+240000 30
+240010 60
+240021 45
+240079 112.66666666667
+240210 45
+240227 45
+240249 75
+240273 75
+240333 30
+240335 60
+300024 96.5
+310001 45
+310025 45
+310034 60
+310042 30
+310111 75
+310191 45
+310219 75
+310236 15
+310322 45
+310356 30
+310360 21.25
+310394 29.5
+310405 75
+310411 60
diff '--color=auto' -Naur php-8.4.18/ext/opcache/tests/jit/gh21267_blacklist.phpt php-8.4.20RC1/ext/opcache/tests/jit/gh21267_blacklist.phpt
--- php-8.4.18/ext/opcache/tests/jit/gh21267_blacklist.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/tests/jit/gh21267_blacklist.phpt	2026-04-01 04:35:36.014945122 +0000
@@ -0,0 +1,36 @@
+--TEST--
+GH-21267 (JIT infinite loop on FETCH_OBJ_R with IS_UNDEF via blacklisted trace exit)
+--INI--
+opcache.enable=1
+opcache.enable_cli=1
+opcache.jit=tracing
+opcache.jit_buffer_size=64M
+opcache.jit_hot_loop=0
+opcache.jit_hot_func=2
+opcache.jit_hot_return=0
+opcache.jit_hot_side_exit=1
+opcache.jit_max_side_traces=0
+--FILE--
+<?php
+class C {
+    public $x = true;
+    public function __get($name) { return null; }
+    public function getX() { return $this->x; }
+}
+
+$o1 = new C;
+$o2 = new C;
+$o2->x = false;
+$o3 = new C;
+unset($o3->x);
+$a = [$o1, $o2, $o3];
+
+for ($i = 0; $i < 8; $i++) {
+    $m = $a[$i % 3];
+    $m->getX();
+    $m->getX();
+}
+?>
+OK
+--EXPECT--
+OK
diff '--color=auto' -Naur php-8.4.18/ext/opcache/tests/jit/gh21267.phpt php-8.4.20RC1/ext/opcache/tests/jit/gh21267.phpt
--- php-8.4.18/ext/opcache/tests/jit/gh21267.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/tests/jit/gh21267.phpt	2026-04-01 04:35:36.014864069 +0000
@@ -0,0 +1,35 @@
+--TEST--
+GH-21267 (JIT infinite loop on FETCH_OBJ_R with IS_UNDEF property in polymorphic context)
+--INI--
+opcache.enable=1
+opcache.enable_cli=1
+opcache.jit=tracing
+opcache.jit_buffer_size=64M
+opcache.jit_hot_loop=0
+opcache.jit_hot_func=2
+opcache.jit_hot_return=0
+opcache.jit_hot_side_exit=1
+--FILE--
+<?php
+class C {
+    public $x = true;
+    public function __get($name) { return null; }
+    public function getX() { return $this->x; }
+}
+
+$o1 = new C;
+$o2 = new C;
+$o2->x = false;
+$o3 = new C;
+unset($o3->x);
+$a = [$o1, $o2, $o3];
+
+for ($i = 0; $i < 8; $i++) {
+    $m = $a[$i % 3];
+    $m->getX();
+    $m->getX();
+}
+?>
+OK
+--EXPECT--
+OK
diff '--color=auto' -Naur php-8.4.18/ext/opcache/zend_accelerator_util_funcs.c php-8.4.20RC1/ext/opcache/zend_accelerator_util_funcs.c
--- php-8.4.18/ext/opcache/zend_accelerator_util_funcs.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/zend_accelerator_util_funcs.c	2026-04-01 04:35:36.015047886 +0000
@@ -360,6 +360,12 @@
 					: NULL;
 				if (parent_ce || (orig_ce->ce_flags & ZEND_ACC_LINKED)) {
 					ce = zend_try_early_bind(orig_ce, parent_ce, early_binding->lcname, zv);
+				} else if (ZSTR_LEN(early_binding->lc_parent_name) == 0) {
+					/* Parentless class: use the same binding path as the VM handler */
+					zval lcname_zv[2];
+					ZVAL_STR(&lcname_zv[0], early_binding->lcname);
+					ZVAL_STR(&lcname_zv[1], early_binding->rtd_key);
+					ce = zend_bind_class_in_slot(zv, lcname_zv, early_binding->lc_parent_name);
 				}
 			}
 			if (ce && early_binding->cache_slot != (uint32_t) -1) {
diff '--color=auto' -Naur php-8.4.18/ext/openssl/openssl.c php-8.4.20RC1/ext/openssl/openssl.c
--- php-8.4.18/ext/openssl/openssl.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/openssl/openssl.c	2026-04-01 04:35:36.015288010 +0000
@@ -2291,21 +2291,13 @@
 	X509_INFO *xi;
 	char cert_path[MAXPATHLEN];
 
-	if(!(stack = sk_X509_new_null())) {
-		php_openssl_store_errors();
-		php_error_docref(NULL, E_ERROR, "Memory allocation failure");
-		goto end;
-	}
-
 	if (!php_openssl_check_path(cert_file, cert_file_len, cert_path, arg_num)) {
-		sk_X509_free(stack);
 		goto end;
 	}
 
 	if (!(in = BIO_new_file(cert_path, PHP_OPENSSL_BIO_MODE_R(PKCS7_BINARY)))) {
 		php_openssl_store_errors();
 		php_error_docref(NULL, E_WARNING, "Error opening the file, %s", cert_path);
-		sk_X509_free(stack);
 		goto end;
 	}
 
@@ -2313,7 +2305,11 @@
 	if (!(sk = PEM_X509_INFO_read_bio(in, NULL, NULL, NULL))) {
 		php_openssl_store_errors();
 		php_error_docref(NULL, E_WARNING, "Error reading the file, %s", cert_path);
-		sk_X509_free(stack);
+		goto end;
+	}
+
+	if(!(stack = sk_X509_new_reserve(NULL, sk_X509_INFO_num(sk)))) {
+		php_openssl_store_errors();
 		goto end;
 	}
 
@@ -2585,7 +2581,10 @@
 				}
 
 			}
-			sk_X509_push(sk, cert);
+			if (sk_X509_push(sk, cert) <= 0) {
+				X509_free(cert);
+				goto push_fail_exit;
+			}
 		} ZEND_HASH_FOREACH_END();
 	} else {
 		/* a single certificate */
@@ -2603,11 +2602,20 @@
 				goto clean_exit;
 			}
 		}
-		sk_X509_push(sk, cert);
+		if (sk_X509_push(sk, cert) <= 0) {
+			X509_free(cert);
+			goto push_fail_exit;
+		}
 	}
 
 clean_exit:
 	return sk;
+
+push_fail_exit:
+	php_openssl_store_errors();
+	php_sk_X509_free(sk);
+	sk = NULL;
+	goto clean_exit;
 }
 /* }}} */
 
@@ -2676,6 +2684,9 @@
 
 	if (args && (item = zend_hash_str_find(Z_ARRVAL_P(args), "extracerts", sizeof("extracerts")-1)) != NULL) {
 		ca = php_array_to_X509_sk(item, 5, "extracerts");
+		if (!ca) {
+			goto cleanup;
+		}
 	}
 	/* end parse extra config */
 
@@ -2769,6 +2780,9 @@
 
 	if (args && (item = zend_hash_str_find(Z_ARRVAL_P(args), "extracerts", sizeof("extracerts")-1)) != NULL) {
 		ca = php_array_to_X509_sk(item, 5, "extracerts");
+		if (!ca) {
+			goto cleanup;
+		}
 	}
 	/* end parse extra config */
 
@@ -3814,7 +3828,10 @@
 /* {{{ php_openssl_generate_private_key */
 static EVP_PKEY * php_openssl_generate_private_key(struct php_x509_request * req)
 {
-	if (req->priv_key_bits < MIN_KEY_LENGTH) {
+	if ((req->priv_key_type == OPENSSL_KEYTYPE_RSA ||
+			req->priv_key_type == OPENSSL_KEYTYPE_DH ||
+			req->priv_key_type == OPENSSL_KEYTYPE_DSA) &&
+			req->priv_key_bits < MIN_KEY_LENGTH) {
 		php_error_docref(NULL, E_WARNING, "Private key length must be at least %d bits, configured to %d",
 			MIN_KEY_LENGTH, req->priv_key_bits);
 		return NULL;
@@ -5835,7 +5852,10 @@
 					goto clean_exit;
 				}
 			}
-			sk_X509_push(recipcerts, cert);
+			if (sk_X509_push(recipcerts, cert) <= 0) {
+				X509_free(cert);
+				goto clean_exit;
+			}
 		} ZEND_HASH_FOREACH_END();
 	} else {
 		/* a single certificate */
@@ -5856,7 +5876,10 @@
 				goto clean_exit;
 			}
 		}
-		sk_X509_push(recipcerts, cert);
+		if (sk_X509_push(recipcerts, cert) <= 0) {
+			X509_free(cert);
+			goto clean_exit;
+		}
 	}
 
 	/* sanity check the cipher */
@@ -5877,16 +5900,21 @@
 	/* tack on extra headers */
 	if (zheaders) {
 		ZEND_HASH_FOREACH_STR_KEY_VAL(Z_ARRVAL_P(zheaders), strindex, zcertval) {
+			int ret;
 			zend_string *str = zval_try_get_string(zcertval);
 			if (UNEXPECTED(!str)) {
 				goto clean_exit;
 			}
 			if (strindex) {
-				BIO_printf(outfile, "%s: %s\n", ZSTR_VAL(strindex), ZSTR_VAL(str));
+				ret = BIO_printf(outfile, "%s: %s\n", ZSTR_VAL(strindex), ZSTR_VAL(str));
 			} else {
-				BIO_printf(outfile, "%s\n", ZSTR_VAL(str));
+				ret = BIO_printf(outfile, "%s\n", ZSTR_VAL(str));
 			}
 			zend_string_release(str);
+			if (ret < 0) {
+				php_openssl_store_errors();
+				goto clean_exit;
+			}
 		} ZEND_HASH_FOREACH_END();
 	}
 
@@ -6105,6 +6133,7 @@
 			zend_string_release(str);
 			if (ret < 0) {
 				php_openssl_store_errors();
+				goto clean_exit;
 			}
 		} ZEND_HASH_FOREACH_END();
 	}
@@ -6444,7 +6473,10 @@
 					goto clean_exit;
 				}
 			}
-			sk_X509_push(recipcerts, cert);
+			if (sk_X509_push(recipcerts, cert) <= 0) {
+				php_openssl_store_errors();
+				goto clean_exit;
+			}
 		} ZEND_HASH_FOREACH_END();
 	} else {
 		/* a single certificate */
@@ -6464,7 +6496,10 @@
 				goto clean_exit;
 			}
 		}
-		sk_X509_push(recipcerts, cert);
+		if (sk_X509_push(recipcerts, cert) <= 0) {
+			php_openssl_store_errors();
+			goto clean_exit;
+		}
 	}
 
 	/* sanity check the cipher */
@@ -6489,16 +6524,21 @@
 	/* tack on extra headers */
 	if (zheaders && encoding == ENCODING_SMIME) {
 		ZEND_HASH_FOREACH_STR_KEY_VAL(Z_ARRVAL_P(zheaders), strindex, zcertval) {
+			int ret;
 			zend_string *str = zval_try_get_string(zcertval);
 			if (UNEXPECTED(!str)) {
 				goto clean_exit;
 			}
 			if (strindex) {
-				BIO_printf(outfile, "%s: %s\n", ZSTR_VAL(strindex), ZSTR_VAL(str));
+				ret = BIO_printf(outfile, "%s: %s\n", ZSTR_VAL(strindex), ZSTR_VAL(str));
 			} else {
-				BIO_printf(outfile, "%s\n", ZSTR_VAL(str));
+				ret = BIO_printf(outfile, "%s\n", ZSTR_VAL(str));
 			}
 			zend_string_release(str);
+			if (ret < 0) {
+				php_openssl_store_errors();
+				goto clean_exit;
+			}
 		} ZEND_HASH_FOREACH_END();
 	}
 
@@ -6778,6 +6818,7 @@
 			zend_string_release(str);
 			if (ret < 0) {
 				php_openssl_store_errors();
+				goto clean_exit;
 			}
 		} ZEND_HASH_FOREACH_END();
 	}
diff '--color=auto' -Naur php-8.4.18/ext/openssl/tests/gh21083.phpt php-8.4.20RC1/ext/openssl/tests/gh21083.phpt
--- php-8.4.18/ext/openssl/tests/gh21083.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/openssl/tests/gh21083.phpt	2026-04-01 04:35:36.015727841 +0000
@@ -0,0 +1,61 @@
+--TEST--
+GH-21083 (openssl_pkey_new() fails for EC keys when private_key_bits is not set)
+--EXTENSIONS--
+openssl
+--SKIPIF--
+<?php if (!defined("OPENSSL_KEYTYPE_EC")) die("skip EC disabled"); ?>
+--ENV--
+OPENSSL_CONF=
+--FILE--
+<?php
+// Create a minimal openssl.cnf without default_bits (simulates OpenSSL 3.6 default config)
+$conf = tempnam(sys_get_temp_dir(), 'ossl');
+file_put_contents($conf, "[req]\ndistinguished_name = req_dn\n[req_dn]\n");
+
+// EC key - size is determined by the curve, private_key_bits should not be required
+$key = openssl_pkey_new([
+    'config' => $conf,
+    'private_key_type' => OPENSSL_KEYTYPE_EC,
+    'curve_name' => 'prime256v1',
+]);
+var_dump($key !== false);
+$details = openssl_pkey_get_details($key);
+var_dump($details['bits']);
+var_dump($details['type'] === OPENSSL_KEYTYPE_EC);
+echo "EC OK\n";
+
+// X25519 - fixed size key, private_key_bits should not be required
+if (defined('OPENSSL_KEYTYPE_X25519')) {
+    $key = openssl_pkey_new([
+        'config' => $conf,
+        'private_key_type' => OPENSSL_KEYTYPE_X25519,
+    ]);
+    var_dump($key !== false);
+    echo "X25519 OK\n";
+} else {
+    echo "bool(true)\nX25519 OK\n";
+}
+
+// Ed25519 - fixed size key, private_key_bits should not be required
+if (defined('OPENSSL_KEYTYPE_ED25519')) {
+    $key = openssl_pkey_new([
+        'config' => $conf,
+        'private_key_type' => OPENSSL_KEYTYPE_ED25519,
+    ]);
+    var_dump($key !== false);
+    echo "Ed25519 OK\n";
+} else {
+    echo "bool(true)\nEd25519 OK\n";
+}
+
+unlink($conf);
+?>
+--EXPECT--
+bool(true)
+int(256)
+bool(true)
+EC OK
+bool(true)
+X25519 OK
+bool(true)
+Ed25519 OK
diff '--color=auto' -Naur php-8.4.18/ext/pcntl/pcntl.c php-8.4.20RC1/ext/pcntl/pcntl.c
--- php-8.4.18/ext/pcntl/pcntl.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/pcntl/pcntl.c	2026-04-01 04:35:36.015863858 +0000
@@ -798,15 +798,16 @@
 		RETURN_THROWS();
 	}
 
-	/* Add the function name to our signal table */
-	handle = zend_hash_index_update(&PCNTL_G(php_signal_table), signo, handle);
-	Z_TRY_ADDREF_P(handle);
-
+	/* Register with the OS first so that on failure we don't record a handler that was never installed */
 	if (php_signal4(signo, pcntl_signal_handler, (int) restart_syscalls, 1) == (void *)SIG_ERR) {
 		PCNTL_G(last_error) = errno;
 		php_error_docref(NULL, E_WARNING, "Error assigning signal");
 		RETURN_FALSE;
 	}
+
+	/* Add the function name to our signal table */
+	handle = zend_hash_index_update(&PCNTL_G(php_signal_table), signo, handle);
+	Z_TRY_ADDREF_P(handle);
 	RETURN_TRUE;
 }
 /* }}} */
@@ -1342,6 +1343,7 @@
 
 	queue = PCNTL_G(head);
 	PCNTL_G(head) = NULL; /* simple stores are atomic */
+	PCNTL_G(tail) = NULL;
 
 	/* Allocate */
 	while (queue) {
@@ -1363,6 +1365,9 @@
 #ifdef HAVE_STRUCT_SIGINFO_T
 				zval_ptr_dtor(&params[1]);
 #endif
+				if (EG(exception)) {
+					break;
+				}
 			}
 		}
 
@@ -1372,6 +1377,14 @@
 		queue = next;
 	}
 
+	/* drain the remaining in case of exception thrown */
+	while (queue) {
+		next = queue->next;
+		queue->next = PCNTL_G(spares);
+		PCNTL_G(spares) = queue;
+		queue = next;
+	}
+
 	PCNTL_G(pending_signals) = 0;
 
 	/* Re-enable queue */
@@ -1584,7 +1597,7 @@
 
 	pid = pid_is_null ? getpid() : pid;
 	fd = syscall(SYS_pidfd_open, pid, 0);
-	if (errno) {
+	if (fd == -1) {
 		PCNTL_G(last_error) = errno;
 		switch (errno) {
 			case EINVAL:
@@ -1610,11 +1623,12 @@
 		RETURN_FALSE;
 	}
 	ret = setns(fd, (int)nstype);
+	int setns_errno = errno;
 	close(fd);
 
 	if (ret == -1) {
-		PCNTL_G(last_error) = errno;
-		switch (errno) {
+		PCNTL_G(last_error) = setns_errno;
+		switch (setns_errno) {
 			case ESRCH:
 				zend_argument_value_error(1, "process no longer available (" ZEND_LONG_FMT ")", pid);
 				RETURN_THROWS();
@@ -1624,11 +1638,11 @@
 				RETURN_THROWS();
 
 			case EPERM:
-				php_error_docref(NULL, E_WARNING, "Error %d: No required capability for this process", errno);
+				php_error_docref(NULL, E_WARNING, "Error %d: No required capability for this process", setns_errno);
 				break;
 
 			default:
-			        php_error_docref(NULL, E_WARNING, "Error %d", errno);
+			        php_error_docref(NULL, E_WARNING, "Error %d", setns_errno);
 		}
 		RETURN_FALSE;
 	} else {
@@ -1733,6 +1747,7 @@
 
 		if (cpu < 0 || cpu >= maxcpus) {
 			zend_argument_value_error(2, "cpu id must be between 0 and " ZEND_ULONG_FMT " (" ZEND_LONG_FMT ")", maxcpus, cpu);
+			PCNTL_CPU_DESTROY(mask);
 			RETURN_THROWS();
 		}
 
diff '--color=auto' -Naur php-8.4.18/ext/pcntl/tests/pcntl_signal_dispatch_exception.phpt php-8.4.20RC1/ext/pcntl/tests/pcntl_signal_dispatch_exception.phpt
--- php-8.4.18/ext/pcntl/tests/pcntl_signal_dispatch_exception.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/pcntl/tests/pcntl_signal_dispatch_exception.phpt	2026-04-01 04:35:36.016037105 +0000
@@ -0,0 +1,34 @@
+--TEST--
+pcntl_signal_dispatch() stops dispatching after handler throws exception
+--EXTENSIONS--
+pcntl
+posix
+--FILE--
+<?php
+
+$called = [];
+
+pcntl_signal(SIGUSR1, function ($signo) use (&$called) {
+    $called[] = 'SIGUSR1';
+    throw new \Exception('Exception in signal handler');
+});
+
+pcntl_signal(SIGUSR2, function ($signo) use (&$called) {
+    $called[] = 'SIGUSR2';
+});
+
+posix_kill(posix_getpid(), SIGUSR1);
+posix_kill(posix_getpid(), SIGUSR2);
+
+try {
+    pcntl_signal_dispatch();
+} catch (\Exception $e) {
+    echo $e->getMessage() . "\n";
+}
+
+echo "Handlers called: " . implode(', ', $called) . "\n";
+
+?>
+--EXPECT--
+Exception in signal handler
+Handlers called: SIGUSR1
diff '--color=auto' -Naur php-8.4.18/ext/pcntl/tests/pcntl_signal_functions_invalid_signals.phpt php-8.4.20RC1/ext/pcntl/tests/pcntl_signal_functions_invalid_signals.phpt
--- php-8.4.18/ext/pcntl/tests/pcntl_signal_functions_invalid_signals.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/pcntl/tests/pcntl_signal_functions_invalid_signals.phpt	2026-04-01 04:35:36.016099994 +0000
@@ -0,0 +1,80 @@
+--TEST--
+pcntl_sigprocmask(), pcntl_sigwaitinfo(), and pcntl_sigtimedwait() properly throw on invalid signals
+--EXTENSIONS--
+pcntl
+--SKIPIF--
+<?php
+if (!function_exists("pcntl_sigprocmask")) die("skip pcntl_sigprocmask() not available");
+if (!function_exists("pcntl_sigwaitinfo")) die("skip pcntl_sigwaitinfo() not available");
+if (!function_exists("pcntl_sigtimedwait")) die("skip pcntl_sigtimedwait() not available");
+?>
+--INI--
+max_execution_time=0
+--FILE--
+<?php
+
+try {
+    pcntl_sigprocmask(SIG_BLOCK, ["not_a_signal"]);
+} catch (TypeError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+try {
+    pcntl_sigprocmask(SIG_BLOCK, [0]);
+} catch (ValueError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+try {
+    pcntl_sigprocmask(SIG_BLOCK, []);
+} catch (ValueError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+try {
+    pcntl_sigwaitinfo(["not_a_signal"]);
+} catch (TypeError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+try {
+    pcntl_sigwaitinfo([0]);
+} catch (ValueError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+try {
+    pcntl_sigwaitinfo([]);
+} catch (ValueError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+try {
+    pcntl_sigtimedwait(["not_a_signal"], $info, 1);
+} catch (TypeError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+try {
+    pcntl_sigtimedwait([0], $info, 1);
+} catch (ValueError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+try {
+    pcntl_sigtimedwait([], $info, 1);
+} catch (ValueError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+?>
+--EXPECTF--
+pcntl_sigprocmask(): Argument #2 ($signals) signals must be of type int, string given
+pcntl_sigprocmask(): Argument #2 ($signals) signals must be between 1 and %d
+pcntl_sigprocmask(): Argument #2 ($signals) must not be empty
+pcntl_sigwaitinfo(): Argument #1 ($signals) signals must be of type int, string given
+pcntl_sigwaitinfo(): Argument #1 ($signals) signals must be between 1 and %d
+pcntl_sigwaitinfo(): Argument #1 ($signals) must not be empty
+pcntl_sigtimedwait(): Argument #1 ($signals) signals must be of type int, string given
+pcntl_sigtimedwait(): Argument #1 ($signals) signals must be between 1 and %d
+pcntl_sigtimedwait(): Argument #1 ($signals) must not be empty
diff '--color=auto' -Naur php-8.4.18/ext/pcre/php_pcre.c php-8.4.20RC1/ext/pcre/php_pcre.c
--- php-8.4.18/ext/pcre/php_pcre.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/pcre/php_pcre.c	2026-04-01 04:35:36.016264385 +0000
@@ -840,6 +840,7 @@
 		if (key != regex) {
 			zend_string_release_ex(key, 0);
 		}
+		pcre2_code_free(new_entry.re);
 		php_error_docref(NULL, E_WARNING, "Internal pcre2_pattern_info() error %d", rc);
 		pcre_handle_exec_error(PCRE2_ERROR_INTERNAL);
 		return NULL;
@@ -850,6 +851,7 @@
 		if (key != regex) {
 			zend_string_release_ex(key, 0);
 		}
+		pcre2_code_free(new_entry.re);
 		php_error_docref(NULL, E_WARNING, "Internal pcre_pattern_info() error %d", rc);
 		pcre_handle_exec_error(PCRE2_ERROR_INTERNAL);
 		return NULL;
@@ -1173,6 +1175,7 @@
 	HashTable		*marks = NULL;		/* Array of marks for PREG_PATTERN_ORDER */
 	pcre2_match_data *match_data;
 	PCRE2_SIZE		 start_offset2, orig_start_offset;
+	bool old_mdata_used;
 
 	char *subject = ZSTR_VAL(subject_str);
 	size_t subject_len = ZSTR_LEN(subject_str);
@@ -1242,7 +1245,9 @@
 	matched = 0;
 	PCRE_G(error_code) = PHP_PCRE_NO_ERROR;
 
-	if (!mdata_used && num_subpats <= PHP_PCRE_PREALLOC_MDATA_SIZE) {
+	old_mdata_used = mdata_used;
+	if (!old_mdata_used && num_subpats <= PHP_PCRE_PREALLOC_MDATA_SIZE) {
+		mdata_used = true;
 		match_data = mdata;
 	} else {
 		match_data = pcre2_match_data_create_from_pattern(pce->re, PCRE_G(gctx_zmm));
@@ -1294,7 +1299,18 @@
 			if (subpats != NULL) {
 				/* Try to get the list of substrings and display a warning if failed. */
 				if (UNEXPECTED(offsets[1] < offsets[0])) {
-					if (match_sets) efree(match_sets);
+					if (match_sets) {
+						for (i = 0; i < num_subpats; i++) {
+							zend_array_destroy(match_sets[i]);
+						}
+						efree(match_sets);
+					}
+					if (marks) {
+						zend_array_destroy(marks);
+					}
+					if (match_data != mdata) {
+						pcre2_match_data_free(match_data);
+					}
 					php_error_docref(NULL, E_WARNING, "Get subpatterns list failed");
 					RETURN_FALSE;
 				}
@@ -1428,6 +1444,7 @@
 	if (match_data != mdata) {
 		pcre2_match_data_free(match_data);
 	}
+	mdata_used = old_mdata_used;
 
 	/* Add the match sets to the output array and clean up */
 	if (match_sets) {
@@ -1489,7 +1506,8 @@
 	/* Compile regex or get it from cache. */
 	pcre_cache_entry *pce;
 	if ((pce = pcre_get_compiled_regex_cache(regex)) == NULL) {
-		RETURN_FALSE;
+		RETVAL_FALSE;
+		goto flf_clean;
 	}
 
 	pce->refcount++;
@@ -1631,6 +1649,7 @@
 	size_t			result_len; 		/* Length of result */
 	zend_string		*result;			/* Result of replacement */
 	pcre2_match_data *match_data;
+	bool old_mdata_used;
 
 	/* Calculate the size of the offsets array, and allocate memory for it. */
 	num_subpats = pce->capture_count + 1;
@@ -1644,7 +1663,9 @@
 	result_len = 0;
 	PCRE_G(error_code) = PHP_PCRE_NO_ERROR;
 
-	if (!mdata_used && num_subpats <= PHP_PCRE_PREALLOC_MDATA_SIZE) {
+	old_mdata_used = mdata_used;
+	if (!old_mdata_used && num_subpats <= PHP_PCRE_PREALLOC_MDATA_SIZE) {
+		mdata_used = true;
 		match_data = mdata;
 	} else {
 		match_data = pcre2_match_data_create_from_pattern(pce->re, PCRE_G(gctx_zmm));
@@ -1846,6 +1867,7 @@
 	if (match_data != mdata) {
 		pcre2_match_data_free(match_data);
 	}
+	mdata_used = old_mdata_used;
 
 	return result;
 }
@@ -2574,6 +2596,7 @@
 	uint32_t		 num_subpats;		/* Number of captured subpatterns */
 	zval			 tmp;
 	pcre2_match_data *match_data;
+	bool old_mdata_used;
 	char *subject = ZSTR_VAL(subject_str);
 
 	no_empty = flags & PREG_SPLIT_NO_EMPTY;
@@ -2600,7 +2623,9 @@
 		goto last;
 	}
 
-	if (!mdata_used && num_subpats <= PHP_PCRE_PREALLOC_MDATA_SIZE) {
+	old_mdata_used = mdata_used;
+	if (!old_mdata_used && num_subpats <= PHP_PCRE_PREALLOC_MDATA_SIZE) {
+		mdata_used = true;
 		match_data = mdata;
 	} else {
 		match_data = pcre2_match_data_create_from_pattern(pce->re, PCRE_G(gctx_zmm));
@@ -2729,6 +2754,7 @@
 	if (match_data != mdata) {
 		pcre2_match_data_free(match_data);
 	}
+	mdata_used = old_mdata_used;
 
 	if (PCRE_G(error_code) != PHP_PCRE_NO_ERROR) {
 		zval_ptr_dtor(return_value);
@@ -2928,6 +2954,7 @@
 	zend_ulong		 num_key;
 	bool		 invert;			/* Whether to return non-matching
 										   entries */
+	bool old_mdata_used;
 	pcre2_match_data *match_data;
 	invert = flags & PREG_GREP_INVERT ? 1 : 0;
 
@@ -2940,7 +2967,9 @@
 
 	PCRE_G(error_code) = PHP_PCRE_NO_ERROR;
 
-	if (!mdata_used && num_subpats <= PHP_PCRE_PREALLOC_MDATA_SIZE) {
+	old_mdata_used = mdata_used;
+	if (!old_mdata_used && num_subpats <= PHP_PCRE_PREALLOC_MDATA_SIZE) {
+		mdata_used = true;
 		match_data = mdata;
 	} else {
 		match_data = pcre2_match_data_create_from_pattern(pce->re, PCRE_G(gctx_zmm));
@@ -3005,6 +3034,7 @@
 	if (match_data != mdata) {
 		pcre2_match_data_free(match_data);
 	}
+	mdata_used = old_mdata_used;
 }
 /* }}} */
 
diff '--color=auto' -Naur php-8.4.18/ext/pcre/tests/pcre_reentrancy.phpt php-8.4.20RC1/ext/pcre/tests/pcre_reentrancy.phpt
--- php-8.4.18/ext/pcre/tests/pcre_reentrancy.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/pcre/tests/pcre_reentrancy.phpt	2026-04-01 04:35:36.016544294 +0000
@@ -0,0 +1,58 @@
+--TEST--
+PCRE re-entrancy: nested calls should not corrupt global match data
+--EXTENSIONS--
+pcre
+--FILE--
+<?php
+
+echo "Testing nested PCRE calls..." . PHP_EOL;
+
+$subject = 'abc';
+
+// preg_replace_callback is the most common way to trigger re-entrancy
+$result = preg_replace_callback('/./', function($m) {
+    $char = $m[0];
+    echo "Outer match: $char" . PHP_EOL;
+
+    // 1. Nested preg_match
+    preg_match('/./', 'inner', $inner_m);
+
+    // 2. Nested preg_replace (string version)
+    preg_replace('/n/', 'N', 'inner');
+
+    // 3. Nested preg_split
+    preg_split('/n/', 'inner');
+
+    // 4. Nested preg_grep
+    preg_grep('/n/', ['inner']);
+
+    // If any of the above stole the global mdata buffer without setting mdata_used,
+    // the 'offsets' used by this outer preg_replace_callback loop would be corrupted.
+
+    return strtoupper($char);
+}, $subject);
+
+var_dump($result);
+
+echo PHP_EOL . "Testing deep nesting..." . PHP_EOL;
+
+$result = preg_replace_callback('/a/', function($m) {
+    return preg_replace_callback('/b/', function($m) {
+        return preg_replace_callback('/c/', function($m) {
+            return "SUCCESS";
+        }, 'c');
+    }, 'b');
+}, 'a');
+
+var_dump($result);
+
+?>
+--EXPECT--
+Testing nested PCRE calls...
+Outer match: a
+Outer match: b
+Outer match: c
+string(3) "ABC"
+
+Testing deep nesting...
+string(7) "SUCCESS"
diff '--color=auto' -Naur php-8.4.18/ext/pcre/tests/preg_match_all_negative_length_match.phpt php-8.4.20RC1/ext/pcre/tests/preg_match_all_negative_length_match.phpt
--- php-8.4.18/ext/pcre/tests/preg_match_all_negative_length_match.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/pcre/tests/preg_match_all_negative_length_match.phpt	2026-04-01 04:35:36.016621790 +0000
@@ -0,0 +1,10 @@
+--TEST--
+preg_match_all() resource cleanup when \K in lookahead causes negative-length match
+--FILE--
+<?php
+$result = preg_match_all('/(?=ab\K)a/', 'ab', $matches);
+var_dump($result);
+?>
+--EXPECTF--
+Warning: preg_match_all(): Get subpatterns list failed in %s on line %d
+bool(false)
diff '--color=auto' -Naur php-8.4.18/ext/pcre/tests/preg_match_frameless_leak.phpt php-8.4.20RC1/ext/pcre/tests/preg_match_frameless_leak.phpt
--- php-8.4.18/ext/pcre/tests/preg_match_frameless_leak.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/pcre/tests/preg_match_frameless_leak.phpt	2026-04-01 04:35:36.016708494 +0000
@@ -0,0 +1,23 @@
+--TEST--
+Memory leak in preg_match() frameless function with invalid regex and object arguments
+--FILE--
+<?php
+class Str {
+    private $val;
+    public function __construct($val) {
+        $this->val = str_repeat($val, random_int(1, 1));
+    }
+    public function __toString() {
+        return $this->val;
+    }
+}
+
+$regex = new Str("invalid regex");
+$subject = new Str("some subject");
+
+@preg_match($regex, $subject);
+
+echo "Done";
+?>
+--EXPECT--
+Done
diff '--color=auto' -Naur php-8.4.18/ext/pcre/tests/preg_match_negative_length_match.phpt php-8.4.20RC1/ext/pcre/tests/preg_match_negative_length_match.phpt
--- php-8.4.18/ext/pcre/tests/preg_match_negative_length_match.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/pcre/tests/preg_match_negative_length_match.phpt	2026-04-01 04:35:36.016789287 +0000
@@ -0,0 +1,10 @@
+--TEST--
+preg_match() resource cleanup when \K in lookahead causes negative-length match
+--FILE--
+<?php
+$result = preg_match('/(?=ab\K)a/', 'ab', $matches);
+var_dump($result);
+?>
+--EXPECTF--
+Warning: preg_match(): Get subpatterns list failed in %s on line %d
+bool(false)
diff '--color=auto' -Naur php-8.4.18/ext/pdo_dblib/tests/GHSA-5hqh-c84r-qjcv.phpt php-8.4.20RC1/ext/pdo_dblib/tests/GHSA-5hqh-c84r-qjcv.phpt
--- php-8.4.18/ext/pdo_dblib/tests/GHSA-5hqh-c84r-qjcv.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/pdo_dblib/tests/GHSA-5hqh-c84r-qjcv.phpt	2026-04-01 04:35:36.016897581 +0000
@@ -4,6 +4,7 @@
 pdo_dblib
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE != 4) die("skip for 32bit platforms only");
 if (PHP_OS_FAMILY === "Windows") die("skip not for Windows because the virtual address space for application is only 2GiB");
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
diff '--color=auto' -Naur php-8.4.18/ext/pdo_pgsql/pgsql_driver.c php-8.4.20RC1/ext/pdo_pgsql/pgsql_driver.c
--- php-8.4.18/ext/pdo_pgsql/pgsql_driver.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/pdo_pgsql/pgsql_driver.c	2026-04-01 04:35:36.017003171 +0000
@@ -509,7 +509,7 @@
 					break;
 #endif
 #ifdef CONNECTION_GSS_STARTUP
-				case CONNECTION_SSL_STARTUP:
+				case CONNECTION_GSS_STARTUP:
 					ZVAL_STRINGL(return_value, "Negotiating GSSAPI.", strlen("Negotiating GSSAPI."));
 					break;
 #endif
diff '--color=auto' -Naur php-8.4.18/ext/pdo_sqlite/tests/bug81740.phpt php-8.4.20RC1/ext/pdo_sqlite/tests/bug81740.phpt
--- php-8.4.18/ext/pdo_sqlite/tests/bug81740.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/pdo_sqlite/tests/bug81740.phpt	2026-04-01 04:35:36.017132165 +0000
@@ -5,6 +5,7 @@
 pdo_sqlite
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE != 8) die("skip this test is for 64bit platforms only");
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
 ?>
diff '--color=auto' -Naur php-8.4.18/ext/pgsql/pgsql_arginfo.h php-8.4.20RC1/ext/pgsql/pgsql_arginfo.h
--- php-8.4.18/ext/pgsql/pgsql_arginfo.h	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/pgsql/pgsql_arginfo.h	2026-04-01 04:35:36.017754070 +0000
@@ -1,5 +1,5 @@
 /* This is a generated file, edit the .stub.php file instead.
- * Stub hash: 14b0bdd019480b850940b2c2b012b5f6d51746b8 */
+ * Stub hash: c7e052b85d35ac885704016224e488c67cb83df3 */
 
 ZEND_BEGIN_ARG_WITH_RETURN_OBJ_TYPE_MASK_EX(arginfo_pg_connect, 0, 1, PgSql\\Connection, MAY_BE_FALSE)
 	ZEND_ARG_TYPE_INFO(0, connection_string, IS_STRING, 0)
@@ -828,7 +828,7 @@
 	REGISTER_LONG_CONSTANT("PGSQL_DML_EXEC", PGSQL_DML_EXEC, CONST_PERSISTENT);
 	REGISTER_LONG_CONSTANT("PGSQL_DML_ASYNC", PGSQL_DML_ASYNC, CONST_PERSISTENT);
 	REGISTER_LONG_CONSTANT("PGSQL_DML_STRING", PGSQL_DML_STRING, CONST_PERSISTENT);
-#if defined(PQTRACE_SUPPPRESS_TIMESTAMPS)
+#if defined(PQTRACE_SUPPRESS_TIMESTAMPS)
 	REGISTER_LONG_CONSTANT("PGSQL_TRACE_SUPPRESS_TIMESTAMPS", PQTRACE_SUPPRESS_TIMESTAMPS, CONST_PERSISTENT);
 #endif
 #if defined(PQTRACE_REGRESS_MODE)
diff '--color=auto' -Naur php-8.4.18/ext/pgsql/pgsql.c php-8.4.20RC1/ext/pgsql/pgsql.c
